<template>
	<v-sheet width="384" class="mt-8">
		<v-form @submit.prevent="onSubmit">
			<div class="mt-6 mb-2" :class="{ error: v$.user.name.$errors.length }">
				<label>Username</label>
				<span> *</span>

				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					class="mt-2"
					rounded="lg"
					persistent-hint
					variant="outlined"
					hide-details="auto"
					@blur="v$.user.name.$touch"
					v-model="user.name"
				/>

				<div
					class="mt-0 pt-0"
					v-for="error of v$.user.name.$errors"
					:key="error.$uid"
				>
					<small class="error-msg text-red pt-0 mt-0">{{
						error.$message
					}}</small>
				</div>
			</div>

			<div class="mt-6 mb-2" :class="{ error: v$.user.email.$errors.length }">
				<label>Email address</label>
				<span> *</span>

				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					class="mt-2"
					rounded="lg"
					persistent-hint
					hide-details="auto"
					variant="outlined"
					@blur="v$.user.email.$touch"
					v-model="user.email"
				/>

				<div
					class="mt-0 pt-0"
					v-for="error of v$.user.email.$errors"
					:key="error.$uid"
				>
					<small class="error-msg text-red pt-0 mt-0">{{
						error.$message
					}}</small>
				</div>
				<small class="input-email__explanation">This is your login</small>
			</div>

			<div class="mt-6 mb-2">
				<label>Contact phone</label>

				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					class="mt-2"
					rounded="lg"
					persistent-hint
					hide-details="auto"
					variant="outlined"
					v-model="user.phone"
				/>
			</div>

			<div class="mt-6 mb-2" :class="{ error: v$.user.credit.$errors.length }">
				<label>Credit</label>

				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					class="pt-2"
					rounded="lg"
					variant="outlined"
					hide-details="auto"
					@blur="v$.user.credit.$touch"
					v-model="user.credit"
				/>

				<div
					class="mt-0 pt-0"
					v-for="error of v$.user.credit.$errors"
					:key="error.$uid"
				>
					<small class="error-msg text-red pt-0 mt-0">{{
						error.$message
					}}</small>
				</div>
			</div>

			<div class="mt-6 mb-2" :class="{ error: v$.user.tokens.$errors.length }">
				<label>Aviailable tokens</label>

				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					class="pt-2"
					rounded="lg"
					variant="outlined"
					hide-details="auto"
					@blur="v$.user.tokens.$touch"
					v-model="user.tokens"
				/>

				<div
					class="mt-0 pt-0"
					v-for="error of v$.user.tokens.$errors"
					:key="error.$uid"
				>
					<small class="error-msg text-red pt-0 mt-0">{{
						error.$message
					}}</small>
				</div>
			</div>

			<v-btn class="mt-8" color="#D90E32" height="48" block type="submit">
				{{ titleBtn }}
			</v-btn>
		</v-form>
	</v-sheet>
</template>

<script>
import { useVuelidate } from '@vuelidate/core'
import { required, email, integer } from '@vuelidate/validators'
import { mapGetters } from 'vuex'

export default {
	props: {
		titleBtn: {
			type: String,
			default: '',
		},
	},

	setup() {
		return { v$: useVuelidate() }
	},

	data() {
		return {
			user: {
				name: '',
				email: '',
				phone: '',
				credit: '',
				status: '',
				tokens: '',
			},
		}
	},

	validations() {
		return {
			user: {
				name: { required },
				email: { email, required },
				credit: { integer },
				tokens: { integer },
			},
		}
	},

	computed: {
		...mapGetters(['getEmployeeById']),
	},

	methods: {
		onSubmit() {
			if (this.v$.$invalid) {
				this.v$.$touch()
				return
			}

			console.log('Валидация успешно пройдена!')

			this.$emit('createNewUser', {
				id: Date.now(),
				...this.user,
			})
		},
	},

	created() {
		if (this.$route.params.id) {
			this.user = { ...this.getEmployeeById(this.$route.params.id) }
		}
	},
}
</script>
